/* Copyright (C) 2004-2016 Centro de Computacao Cientifica e Software Livre
 * Departamento de Informatica - Universidade Federal do Parana - C3SL/UFPR
 *
 * This file is part of datasid
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
 * USA.
 */
#pragma once
#include <iostream>
#include <json/json.h>

class Agent{
    private:
        std::string confDir;
        std::string defaultConf;
        std::string logFile;
        std::string prefix;
        std::string version;

    public:
        void setConfDir(std::string);
        void setDefaultConf(std::string);
        void setLogFile(std::string, std::string);
        void setPrefix(std::string, int);
        void setVersion(std::string);

        std::string getConfDir() const;
        std::string getDefaultConf() const;
        std::string getLogFile() const;
        std::string getPrefix() const;
        std::string getVersion() const;
    };


int datasid_agent();
std::string getAbsolutePath( std::string str, int tot);
bool prefixIsSet(std::string prefix);
