/* Copyright (C) 2004-2016 Centro de Computacao Cientifica e Software Livre
 * Departamento de Informatica - Universidade Federal do Parana - C3SL/UFPR
 *
 * This file is part of datasid
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
 * USA.
 */
#pragma once
#include <map>
#include "datasid-agent.h"
#include "datasid-parse.h"
#include "json/json.h"

class Conf{
    private:
        std::string dataDir;
        std::string logDir;
        std::string proxyConf;
        std::string webService;

        int delay;
        int daysToExpireLog;
        int updateTries;
        int updateTimeOut;

    public:
        void setDataDir(std::string);
        void setLogDir(std::string);
        void setProxyConf(std::string);
        void setWebService(std::string);

        void setDelay(int);
        void setDaysToExpireLog(int);
        void setUpdateTries(int);
        void setUpdatTimeOut(int);

        std::string getDataDir() const;
        std::string getLogDir() const;
        std::string getProxyConf() const;
        std::string getWebService() const;

        int getDelay() const;
        int getDaysToExpireLog() const;
        int getUpdateTries() const;
        int getUpdateTimeOut() const;

    };

bool datasid_conf(Agent* agent, Conf* conf, Json::Value& update);
bool setConf(Conf* conf, Agent* agent, std::map<std::string, std::string>* content);
