#!/usr/bin/env bats

function amount_users() {
    expected_number_of_users=3
    obj=$(cat export.json | jq -r '.data.amount_users')
    [[ "$obj" -eq "$expected_number_of_users" ]] && [[ "$obj" != "null" ]]
}

function mac_address() {
    obj=$(cat export.json | jq -r '.data.mac_address')
    [[ "$obj" =~ ^(..:){5}..$ ]] && [[ "$obj" != "null" ]]
}

function machine_type() {
    os=$(cat export.json | jq -r '.data.os_distro')
    obj=$(cat export.json | jq -r '.data.machine_type')
    ! [[ "$os" =~ .*Linux\ Comunicações.* ]] || ( [[ "$os" =~ .*Linux\ Comunicações.* ]] && [[ "$obj" != "null" ]] )

}

function memory() {
    obj=$(cat export.json | jq -r '.data.memory')
    [[ "$obj" -eq "$obj" ]] && [[ "$obj" != "null" ]]
}

function os_distro() {
    obj=$(cat export.json | jq -r '.data.os_distro')
    [[ "$obj" != "null" ]]
}

function os_kernel() {
    obj=$(cat export.json | jq -r '.data.os_kernel')
    [[ "$obj" != "null" ]]
}

function os_type() {
    obj=$(cat export.json | jq -r '.data.os_type')
    [[ "$obj" != "null" ]]
}

function processor() {
    obj=$(cat export.json | jq -r '.data.processor')
    [[ "$obj" != "null" ]]
}

setup() {
    ./../bin/agent-v0.0 | head -n -2 > export.json
    [ -s export.json ]
    cat export.json
}

teardown() {
     rm -f export.json
}

@test "Amount Users" {
    run amount_users
    [ "$status" -eq 0 ]
}

@test "MAC" {
    run mac_address
    [ "$status" -eq 0 ]
}

@test "Machine Type" {
    run machine_type
    [ "$status" -eq 0 ]
}

@test "Memory" {
    run memory
    [ "$status" -eq 0 ]
}

@test "OS Distro" {
    run os_distro
    [ "$status" -eq 0 ]
}

@test "OS Kernel" {
    run os_kernel
    [ "$status" -eq 0 ]
}

@test "OS Type" {
    run os_type
    [ "$status" -eq 0 ]
}

@test "Processor" {
    run processor
    [ "$status" -eq 0 ]
}
